#pragma once

#include "Renderer.hpp"

namespace massivedynamic {

class ConsoleRenderer : public Renderer {
	public:
		ConsoleRenderer(const std::vector<bool>& pixels, size_t sourceSize, size_t targetSize) : Renderer(pixels, sourceSize, targetSize) {}
		virtual void render(const std::string&) override {
			int border = 1;

			std::cout << std::string(border, '\n');
			for (int y = 0; y < sourceSize; y++) {
				std::cout << std::string(border * 2, ' ');
				for (int x = 0; x < sourceSize; x++) {
					bool isFilled = pixels.at(y * sourceSize + x);
					std::cout << (isFilled ? "██" : "  ");
				}
				std::cout << std::string(border * 2, ' ');
				std::cout << '\n';
			}
			std::cout << std::string(border, '\n');
			std::cout << std::endl;
		}
};

}