#pragma once

#include <vector>
#include <string>
#include <memory>
#include <unordered_map>
#include "qrcodegen.hpp"
#include "Renderer.hpp"

namespace massivedynamic {
	typedef uint32_t Color;

	enum class Type {
		SMALL,
		MEDIUM,
		LARGE
	};

	enum class Format {
		CONSOLE,
		SVG,
		PNG
	};

	class QR {
		private:
			std::string outputFile;
			std::vector<bool> pixels;
			std::unordered_map<Format, std::unique_ptr<Renderer>> renderers;
		public:
			QR(const std::string& data, std::string outputFile, size_t size, Type type, Format format);
	};

}